﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace Coursework
{
    /// <summary>
    /// Class stores the values for the three lights of Basic Effect
    /// Each light has a colour, direction and specular
    /// Each light can be turned on or off
    /// </summary>
    class Lighting
    {
        //light 0
        bool light0Enabled;
        Vector3 light0Colour;
        Vector3 light0Direction;
        Vector3 light0SpecularColour;
        //light 1
        bool light1Enabled;
        Vector3 light1Colour;
        Vector3 light1Direction;
        Vector3 light1SpecularColour;
        //light 2
        bool light2Enabled;
        Vector3 light2Colour;
        Vector3 light2Direction;
        Vector3 light2SpecularColour;

        /// <summary>
        /// Set the initial properties of light 0
        /// </summary>
        /// <param name="enabled">Turn it on/off</param>
        /// <param name="colour">light colour</param>
        /// <param name="direction">light direction</param>
        /// <param name="specularColour">specular colour</param>
        public void initLight0(bool enabled, Vector3 colour, Vector3 direction, Vector3 specularColour)
        {
            light0Enabled = enabled;
            light0Colour = colour;
            light0Direction = direction;
            light0SpecularColour = specularColour;

        }

        /// <summary>
        /// Set the initial properties of light 1
        /// </summary>
        /// <param name="enabled">Turn it on/off</param>
        /// <param name="colour">light colour</param>
        /// <param name="direction">light direction</param>
        /// <param name="specularColour">specular colour</param>
        public void initLight1(bool enabled, Vector3 colour, Vector3 direction, Vector3 specularColour)
        {
            light1Enabled = enabled;
            light1Colour = colour;
            light1Direction = direction;
            light1SpecularColour = specularColour;
        }

        /// <summary>
        /// Set the initial properties of light 2
        /// </summary>
        /// <param name="enabled">Turn it on/off</param>
        /// <param name="colour">light colour</param>
        /// <param name="direction">light direction</param>
        /// <param name="specularColour">specular colour</param>
        public void initLight2(bool enabled, Vector3 colour, Vector3 direction, Vector3 specularColour)
        {
            light2Enabled = enabled;
            light2Colour = colour;
            light2Direction = direction;
            light2SpecularColour = specularColour;
        }

        //getter/setter methods for each light and their properties
        //light 0
        public bool lite0Enabled { get { return light0Enabled; } set { light0Enabled = value; } }
        public Vector3 lite0Colour { get { return light0Colour; } set { light0Colour = value; } }
        public Vector3 lite0Direction { get { return light0Direction; } set { light0Direction = value; } }
        public Vector3 lite0SpecularColour { get { return light0SpecularColour; } set { light0SpecularColour = value; } }
        //light 1
        public bool lite1Enabled { get { return light1Enabled; } set { light1Enabled = value; } }
        public Vector3 lite1Colour { get { return light1Colour; } set { light1Colour = value; } }
        public Vector3 lite1Direction { get { return light1Direction; } set { light1Direction = value; } }
        public Vector3 lite1SpecularColour { get { return light1SpecularColour; } set { light1SpecularColour = value; } }
        //light 2
        public bool lite2Enabled { get { return light2Enabled; } set { light2Enabled = value; } }
        public Vector3 lite2Colour { get { return light2Colour; } set { light2Colour = value; } }
        public Vector3 lite2Direction { get { return light2Direction; } set { light2Direction = value; } }
        public Vector3 lite2SpecularColour { get { return light2SpecularColour; } set { light2SpecularColour = value; } }    
    }
}
